/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2002- hiyohiyo All rights reserved.
/*---------------------------------------------------------------------------*/

#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include "InstDrv.h"

extern HANDLE handle;

static BOOL OpenDriver();
static BOOL LoadDeviceDriver(char *FileName, char *DriverName);

BOOL LoadDriver(char *FileName, char *DriverName)
{
	char str[MAX_PATH],tmp[MAX_PATH];
	char *p;

	if(OpenDriver()) {
		return TRUE;
	}

	GetModuleFileName(NULL,str,MAX_PATH);
	if ( (p = strrchr(str,'\\')) != NULL ){
		*p = '\0';
	}
	wsprintf(tmp,"%s\\%s",str,FileName);

	if(LoadDeviceDriver(tmp, DriverName) == FALSE){
		return FALSE;
	}

	if(OpenDriver()) {
		return TRUE;
	}
	return FALSE;
}

BOOL UnloadDriver(char *DriverName)
{
	SC_HANDLE	hSCManager;
	SC_HANDLE	hService;
	SERVICE_STATUS  serviceStatus;
	BOOL	ret = FALSE;

    hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if(!hSCManager)
		return FALSE;

    hService = OpenService(hSCManager, DriverName, SERVICE_ALL_ACCESS);

	if(hService) {
	    ret = ControlService(hService, SERVICE_CONTROL_STOP, &serviceStatus);
	    if(ret == TRUE)
	        ret = DeleteService(hService);
	    CloseServiceHandle(hService);
	}
    CloseServiceHandle(hSCManager);
	CloseHandle(handle);
	handle = NULL;

    return ret;
}

static BOOL OpenDriver()
{
	handle = CreateFile(
		DRIVER_NAME_FULL,
        GENERIC_READ | GENERIC_WRITE,
        FILE_SHARE_READ,
        NULL,
        OPEN_EXISTING,
        0,
        NULL
        );

    if(handle == INVALID_HANDLE_VALUE)
    {
        return FALSE;
    }
	return TRUE;
}

static BOOL LoadDeviceDriver(char *FileName, char *DriverName)
{
	SC_HANDLE	hSCManager;
	SC_HANDLE	hService;
	SERVICE_STATUS	serviceStatus;
	BOOL	ret;

	hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if(!hSCManager)
		return FALSE;

	hService = OpenService( hSCManager,
							DriverName,
							SERVICE_ALL_ACCESS);

	if(hService){
	    ret = ControlService(hService, SERVICE_CONTROL_STOP, &serviceStatus);
        ret = DeleteService(hService);
	    CloseServiceHandle(hService);
	}

	hService = CreateService(hSCManager,
		DriverName,
		DriverName,
		SERVICE_ALL_ACCESS,
		SERVICE_KERNEL_DRIVER,
		SERVICE_DEMAND_START,
		SERVICE_ERROR_NORMAL,
		FileName,
		NULL,NULL,NULL,NULL,NULL);

   ret = FALSE;
   if(hService){
		ret = StartService(hService, 0, NULL);
		CloseServiceHandle(hService);
	}
	CloseServiceHandle(hSCManager);

	return ret;
}

